<?php
	require '../tmp/sql.php';
	require '../classes/mysql.php';
	
	$sql = new MySQL(); if ($sql->debug) error_reporting (E_ALL|E_STRICT); else error_reporting (0);
	
	require '../plugins/phpQuery.php';
	require '../classes/settings.php';
	require '../classes/security.php';
	require '../classes/functions.php';
	require '../classes/session.php';
	require '../classes/login.php';
	require '../classes/template.php';
	
	$secure = new Security();
	$settings = new Settings();
	$func = new Functions();
	$login = new Login(Session::getSID());
	$tpl = new Templates();
	$tpl->load_phrases("gui", true);
	$tpl->load_phrases("admin", true);
	$tpl->load_phrases("_serv", true);
	
	// Standard-Variablen belegen
	if (trim($settings->get("clanname") != "")) $headline = $tpl->phrase("gamename")." ".$settings->get("clanname"); else $headline = $tpl->phrase("gamename");
	date_default_timezone_set($settings->get("timezone"));
	$sid = session::getSID();
	
	
	### LOGINSCREEN // STANDARDS ###
	if(!$login->logged_in()) {
		// Seitentemplate
		eval ("\$html = \"".$tpl->template("_index")."\";");  $html = phpQuery::newDocumentHTML($html);
		pq('nav')->addClass('hidden');
		
		
		// Installationsordner vorhanden
		if (!$sql->debug AND file_exists('../install/index.php')) {
			$path = $_SERVER['HTTP_HOST']."/".str_replace(array($_SERVER['DOCUMENT_ROOT'], "admin/index.php"), array("", "install/"), $_SERVER['SCRIPT_FILENAME']);
			$path = str_replace("//", "/", $path);
			
			eval ("\$foldercheck = \"".$tpl->template("foldercheck")."\";");
			$foldercheck = phpQuery::newDocumentHTML($foldercheck);
			
			phpQuery::selectDocument($html);
			pq('#wrap')->append($foldercheck);
			die ($html);
		}
		
		// Loginformular einblenden (Installationsordner nicht vorhanden)
		else {
			// Fehlermeldung, falls falscher Username/Password eingegeben wurde
			if (isset($_POST['login'])) pq("aside")->text($tpl->phrase("error_login"))->attr("style", "display: block");
			
			
			// Variablen
			$installed = $settings->get("version");
			$ch = curl_init("http://curl.ezstats.org/?version&game=serv"); curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$actual = curl_exec($ch); curl_close($ch);
			
			
			// Loginformular einbinden
			eval ("\$login = \"".$tpl->template("login")."\";");
			$login = phpQuery::newDocumentHTML($login);
			
			
			// PHP-Info bei Debug=1
			if ($sql->debug) {
				ob_start();
				phpinfo();
				
				$phpinfo = ob_get_clean();
				$phpinfo = phpQuery::newDocumentHTML($phpinfo);
				$phpinfo = pq('.center')->html();
				
				$info = '<div class="clear"></div><section>'.$phpinfo.'</section>';
			} else $info = "";
			
			
			// Seiten-Ausgabe
			phpQuery::selectDocument($html);
			pq('#wrap')->append($login)->append($info);
			die ($html);
		}
	}
	else {
		// Informationen ber den eingeloggten User
		$sql->query('SELECT * FROM '.$sql->prefix.'users WHERE session = "'.$sid.'"');
		$user = $sql->fetchRow();
		
		// Seitentemplate
		eval ("\$html = \"".$tpl->template("_index")."\";");  $html = phpQuery::newDocumentHTML($html);
		if ($user['adminpower'] != "1") pq('nav li[rel=admin]')->addClass('hidden'); // Anzeige der weiteren Nav-Optionen nur mit voller Adminpower
	}
	
	
	### STARTSEITE // RCON-FUNKTION ###
	if (!count($_GET) OR isset($_GET['rcon'])) {
		// Server-Remote
		eval ("\$template = \"".$tpl->template("rcon")."\";");  $template = phpQuery::newDocumentHTML($template);
		$platarray = Array('pc' => 'PC', '360' => 'Xbox360', 'ps3' => 'PS3');
		$i = 0;
		$sql->query('SELECT * FROM '.$sql->prefix.'server ORDER BY `order`');
		while ($server = $sql->fetchRow()) {
			$platform = $platarray[$server['platform']];
			$name     = $server['name'] ? $func->shortening($server['name'], 30) : " ";
			$ip       = $server['ip'] ? $server['ip'] : "0.0.0.0";
			$port     = $server['port'] ? $server['port'] : "00000";
			$string   = strtoupper($server['game']).'&nbsp;&nbsp;&nbsp;'.$platform.'&nbsp;&nbsp;&nbsp;'.$ip.':'.$port.' | '.$name;
			
			$option = '<option value="'.$server['id'].'">'.$string.'</option>';
			pq('#serverselect')->append($option); // Server-Auswahlmenu
			
			if ($i == 0) pq('#id')->attr("value", $server['id']); // ID des ersten Servers fr das erste Aufrufen
			$i++;
		}
		
		
		// Seite ausgeben
		phpQuery::selectDocument($html);
		if ($sql->count()) pq('#wrap')->append($template); // RCON-Formular nur einblenden, wenn mind. ein Server vorhanden ist
		die ($html);
	}
	
	
	### SERVER HINZUFGEN ###
	if (isset($_GET['add'])) {
		if ($user['adminpower'] != "1") die ($html);  // Abbruch wenn ungengende Adminrechte
		
		// Template laden
		eval ("\$addserver = \"".$tpl->template("addserver")."\";");
		$addserver = phpQuery::newDocumentHTML($addserver);
		
		if (isset($_GET['edit'])) {
			// Server editieren -> Werte voreinstellen
			$sql->query('SELECT * FROM '.$sql->prefix.'server WHERE id="'.$_GET['edit'].'"');
			$server = $sql->fetchRow();
			
			pq('#id')         ->val($server['id']);
			pq('[name=game]')->filter('[value='.$server['game'].']')->attr("checked", "checked");
			pq('[name=platform]')->filter('[value='.$server['platform'].']')->attr("checked", "checked");
			pq('#serverdesc')->append($server['description']);
			pq('#serverid')  ->val($server['serverid']);
			pq('#name')      ->val($server['name']);
			pq('#ip')        ->val($server['ip']);
			pq('#port')      ->val($server['port']);
			pq('#password')  ->val($server['password']);
			
			pq('[name=procon_show]')->filter('[value='.$server['procon_show'].']')->attr("checked", "checked");
			pq('#procon_count')   ->val($server['procon_count']);
			pq('#procon_servid')  ->val($server['procon_servid']);
			pq('#procon_url')     ->val($server['procon_url']);
			pq('#procon_sqlhost') ->val($server['procon_sqlhost']);
			pq('#procon_sqldb')   ->val($server['procon_sqldb']);
			pq('#procon_sqluser') ->val($server['procon_sqluser']);
			pq('#procon_sqlpwd')  ->val($server['procon_sqlpwd']);
			pq('#procon_prefix')  ->val($server['procon_prefix']);
			
			pq('[name=xlrstats_show]')->filter('[value='.$server['xlrstats_show'].']')->attr("checked", "checked");
			pq('#xlrstats_count')   ->val($server['xlrstats_count']);
			pq('#xlrstats_url')     ->val($server['xlrstats_url']);
			pq('#xlrstats_sqlhost') ->val($server['xlrstats_sqlhost']);
			pq('#xlrstats_sqldb')   ->val($server['xlrstats_sqldb']);
			pq('#xlrstats_sqluser') ->val($server['xlrstats_sqluser']);
			pq('#xlrstats_sqlpwd')  ->val($server['xlrstats_sqlpwd']);
			pq('#xlrstats_prefix')  ->val($server['xlrstats_prefix']);
		}
		else {
			// Neuer Server -> Plattform voreintstellen
			$sql->query('SELECT value FROM '.$sql->prefix.'settings WHERE name = "platform"');
			$result = $sql->fetchRow("value");
			pq('[name=platform]')->filter('[value='.$result.']')->attr("checked", "checked");
		}
		
		### SEITE AUSGEBEN ###
		phpQuery::selectDocument($html);
		pq('#wrap')->append($addserver);
		die ($html);
	}
	
	
	### SERVER BEARBEITEN ###
	if (isset($_GET['edit'])) {
		if ($user['adminpower'] != "1") die ($html);  // Abbruch wenn ungengende Adminrechte
		
		// Template laden
		eval ("\$template = \"".$tpl->template("editserver")."\";");
		$template = phpQuery::newDocumentHTML($template);
		
		
		// Listenelemente generieren
		$sql->query('SELECT * FROM '.$sql->prefix.'server ORDER BY `order`');
		
		
		while ($server = $sql->fetchRow()) {
			$game     = '<img src="../stylesheets/images/icon_'.$server['game'].'.png" width="16" height="16" alt="'.$server['game'].'" />';
			$platform = '<img src="../stylesheets/images/icon_'.$server['platform'].'.png" width="16" height="16" alt="'.$server['platform'].'" />';
			$name     = $server['name'] ? $func->shortening($server['name'], 60) : " ";
			$ip       = $server['ip'] ? $server['ip'] : "0.0.0.0";
			$port     = $server['port'] ? $server['port'] : "00000";
			$string   = $game.'&nbsp;&nbsp;&nbsp;'.$platform.'&nbsp;&nbsp;&nbsp;'.$ip.':'.$port.' | '.$name;
			
			$string = '
				<li rel="'.$server['id'].'"><span>
					<a href="#" class="button" action="edit">'.$tpl->phrase("edit").'</a>
					<a href="#" class="button" action="delete" defphrase="'.$tpl->phrase("delete").'" delphrase="'.$tpl->phrase("delete").'?">'.$tpl->phrase("delete").'</a>
					&nbsp;&nbsp;&nbsp;'.$string.'
				</span></li>
			';
			pq('ul')->append($string);
		}
		
		
		// Seite ausgeben
		phpQuery::selectDocument($html);
		pq('#wrap')->append($template);
		die ($html);
	}
	
	
	### ALLGEMEINE EINSTELLUNGEN ###
	if (isset($_GET['settings'])) {
		if ($user['adminpower'] != "1") die ($html);  // Abbruch wenn ungengende Adminrechte
		
		// Gespeicherte Settings laden
		$preset = $func->load_settings("settings");
		$preset['debug'] = $sql->debug;
		
		
		// Template laden
		eval ("\$settings = \"".$tpl->template("settings")."\";");
		$settings = phpQuery::newDocumentHTML($settings);
		
		
		// Voreinstellungen setzen (Radiobuttons)
		$radio = Array("platform", "ov_infobox", "ov_brand", "debug", "cache", "serv_gameicon", "serv_platicon", "serv_serverlist", "serv_infoheader", "serv_description", "serv_battlelog_url", "serv_settings", "serv_mapcycle", "serv_scoreboard", "serv_servertable");
		foreach ($radio as $name)
			pq('[name='.$name.']')->filter('[value='.$preset[$name].']')->attr("checked", "checked");
		
		
		// Voreinstellungen setzen (Sprache)
		$languages = Array();
		$sql->query('SHOW COLUMNS FROM '.$sql->prefix.'localization');
		
		while ($row = $sql->fetchRow()) {
			if ($row['Field'] != "id" AND $row['Field'] != "category" AND $row['Field'] != "wildcard") 
			$languages[] = $row['Field'];
		}
		
		foreach ($languages as $lang) {
			if ($lang == $preset['language'])
				 pq('<option/>')->text($lang)->attr('selected', 'selected')->appendTo('#language');
			else pq('<option/>')->text($lang)->appendTo('#language');
		}
		
		
		// Voreinstellungen setzen (Zeitzone)
		pq('#timezone')->append($func->select_timezone($preset['timezone']));
		
		
		// Seite ausgeben
		phpQuery::selectDocument($html);
		pq('#wrap')->append($settings);
		die ($html);
	}
	
	
	### CMS-PLUGINS ###
	if (isset($_GET['plugin'])) {
		if ($user['adminpower'] != "1") die ($html);  // Abbruch wenn ungengende Adminrechte
		
		// Pfad erzeugen
		if (!$settings->get("path")) {
			$path = $_SERVER['HTTP_HOST']."/".str_replace($_SERVER['DOCUMENT_ROOT'], "", $_SERVER['SCRIPT_FILENAME']);
			$path = str_replace("\\", "/", $path);
			$path = str_replace("//", "/", $path);
			$path = str_replace("admin/index.php", "", $path);
			
			$path = substr($path, -1)   != "/"       ? $path."/"       : $path;
			$path = substr($path, 0, 7) != "http://" ? "http://".$path : $path;
			
			$settings->set('path', $path, true);
		} else {
			$path = $settings->get('path');
			$settings->set('path', $path, true);
		}
		
		
		// CMS-Plugin-Liste generieren
		$plugins = ""; 
		$sql->query('SELECT code, name FROM '.$sql->prefix.'plugins ORDER BY id');
		
		while ($row = $sql->fetchRow()) {
			if ($settings->get('cms') == $row['code'])
				 $plugins .= '<option selected="selected" value="'.$row['code'].'">'.$row['name'].'</code>';
			else $plugins .= '<option value="'.$row['code'].'">'.$row['name'].'</code>';
		}
		
		
		// Template laden
		eval ("\$plugin = \"".$tpl->template("plugin")."\";");
		$plugin = phpQuery::newDocumentHTML($plugin);
		
		// Seite ausgeben
		phpQuery::selectDocument($html);
		pq('#wrap')->append($plugin);
		die ($html);
	}
	
	
	### STYLE ### 
	if (isset($_GET['style'])) {
		$tpl->load_phrases("style", true);
		$preset = $func->load_settings("style");
		
		// Dropdownmens
		$options_body_bg_image = '
			<option value="">...</option>
			<option>images/background.jpg</option>
			<option>images/background-air.jpg</option>
			<option>images/background-ak.jpg</option>
			<option>images/background-am.jpg</option>
			<option>images/background-as.jpg</option>
			<option>images/background-b2k.jpg</option>
			<option>images/background-coop.jpg</option>
			<option>images/background-eg.jpg</option>
			<option>images/background-mohw1.jpg</option>
			<option>images/background-mohw2.jpg</option>
			<option>images/background-mohw3.jpg</option>
			<option>images/background-mohw4.jpg</option>
		';
		
		$files = Array("images/bg/light10.png", "images/bg/light20.png", "images/bg/light30.png", "images/bg/light40.png", "images/bg/light50.png", "images/bg/light60.png", "images/bg/light70.png", "images/bg/light80.png", "images/bg/light90.png", "images/bg/dark10.png", "images/bg/dark20.png", "images/bg/dark30.png", "images/bg/dark40.png", "images/bg/dark50.png", "images/bg/dark60.png", "images/bg/dark70.png", "images/bg/dark80.png", "images/bg/dark90.png");
		$options_section_bg_image = '<option value="">...</option>';
		foreach ($files as $file) $options_section_bg_image .= '<option>'.$file.'</option>';
		
		
		// Presets
		$options_preset = '';
		if ($presets = json_decode(@file_get_contents("../tmp/styles.js"))) {
			foreach ($presets as $title => $obj) $options_preset .= '<option>'.$title.'</option>';
		} else {
			$options_preset = '<option value="">found no styles.js</option>';
		}
		
		
		// Template laden
		eval ("\$style = \"".$tpl->template("style")."\";");
		$style = phpQuery::newDocumentHTML($style);
		
		
		// Seite ausgeben
		phpQuery::selectDocument($html);
		pq('#wrap')->append($style);
		die ($html);
	}
	
	
	### USER ###
	if (isset($_GET['user'])) {
		if ($user['adminpower'] != "1") die ($html);  // Abbruch wenn ungengende Adminrechte
		
		### USER HINZUFGEN ###
		// Template laden
		eval ("\$adduser = \"".$tpl->template("adduser")."\";");
		$adduser = phpQuery::newDocumentHTML($adduser);
		
		
		### SPIELER VERWALTEN ###
		eval ("\$edituser = \"".$tpl->template("edituser")."\";");
		$edituser = phpQuery::newDocumentHTML($edituser);
		
		
		// Seite zusammenstellen
		eval ("\$user = \"".$tpl->template("user")."\";");
		$user = phpQuery::newDocumentHTML($user);
		pq('#user')->append($adduser);
		pq('#user')->append($edituser);
		
		// Seite ausgeben
		phpQuery::selectDocument($html);
		pq('#wrap')->append($user);
		die ($html);
	}
	
?>